#include <p18f4520.h>
#include "thread_list.h"

struct{
	
	struct{
		char stackpointer:5;
		char spare2:3;
		char TOSU[10];
		char TOSH[10];
		char TOSL[10];
	}stack;
	char priority:5;
	char spare1:3;
	char priority_timer;
	void (*update_from_temp)(void);	
	void (*thread)(void);
}logic_thread;


void LOGICTHREAD(void){
logic_thread.priority_timer = TMR1H;
if (logic_thread.priority_timer+priority[logic_thread.priority]>=256){
logic_thread.priority_timer = 0;
}


if (logic_thread.stack.stackpointer>0){
retrieve_logic_stack();
}
//otherwise continue
TMR0L = 0x00;
INTCONbits.T0IF = 0;	//Reset interrupt flag
INTCONbits.T0IE = 1;	//enable Timer0 Interrupt
INTCONbits.GIE = 1;		//enable Global Interrupts
/////////////////////////CODE HERE//////////////////////////
while(1){			//use a while loop so the thread doesnt exit

tempor=0;//simulate code within the thread

tempor=TMR0L;
tempor=TMR1L;
tempor=TMR1H;
tempor=TMR0L;
tempor=TMR0H;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;
tempor=0;

}
}
void COPY_TEMP_LOGIC_STACK(void){
logic_thread.stack=temporary_stack;
}

void setup_logic_thread(void){
logic_thread.thread=&LOGICTHREAD;
logic_thread.stack.stackpointer = 0;
logic_thread.priority = 1;
logic_thread.update_from_temp = &COPY_TEMP_LOGIC_STACK;
logic_thread.priority_timer = 0x00;
}

void retrieve_logic_stack(void){

//POP ALL LEVELS????

while(STKPTR<=logic_thread.stack.stackpointer){	//while the saved stack pointer is greater than the actual stack pointer
WREG = logic_thread.stack.TOSL[STKPTR & 0b11111];	//load stored address into stack
TOSL = WREG;
WREG = logic_thread.stack.TOSH[STKPTR & 0b11111];
TOSH = WREG;
WREG = logic_thread.stack.TOSU[STKPTR & 0b11111];
TOSU = WREG;
_asm PUSH _endasm	//add another stack level
}
_asm POP _endasm	//remove last stack level
TMR0L = 0x00;
INTCONbits.T0IF = 0;	//Reset interrupt flag
INTCONbits.T0IE = 1;	//enable Timer0 Interrupt
INTCONbits.GIE = 1;		//enable Global Interrupts
return;	//return back to the point of store stack was called (+0x02 to skip over the thread that has just run)

}